


#include <string.h>
#include <stdio.h>

#define N_DATALENGTH 16384    // in units of words  (ie 4096 => 16 Kbyte)

#include <stdlib.h> /* getenv, exit */
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>

extern void checkFEE64DATAbuffer(char*, int);
void printbufferL(char*, int);
void byteswop32(char*, int);
void byteswop316(char*, int);


FILE * InStream;
char *FileName= (char*)"AIDA.dat";

unsigned int DataBuffer[N_DATALENGTH];
size_t count = N_DATALENGTH*4;


void Usage(char *progname) {
    fprintf(stderr,"Usage\n%s -f [file path name]\n",progname);
    fprintf(stderr,"\tfile path name is file name used to read data\n");
    exit(1);
}


int main(int argc, char *argv[], char *envp[])
{

   int i;
   ssize_t bytes;
   char fname[32];
   int blocks = 0;

   extern int Items[];
   extern int GoodItems;

//    command line arguments

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
                    default:
                        Usage(argv[0]);
                        break;
                }
            }
            else
                Usage(argv[0]);
        }
    }

       sprintf(fname,"%s",FileName);
       InStream = fopen(fname,"r");

       if (InStream == NULL) {printf("read from %s failed\n",fname); exit(16);}

       printf("reading from %s\n",fname);

      for (;;) {
         bytes = fread((void*) &DataBuffer[0], 1, count, InStream);
         if (bytes != count) break;

         blocks++;

/*
    note that each 64K byte block starts with a 24 byte header which is constructed within the data receiver program 
*/

//         printbufferL((char *)&DataBuffer[0], bytes);
//         printf("data length = %d bytes\n", DataBuffer[5]);

         if ((DataBuffer[4] & 0x0000ffff) != 1) {
            byteswop32((char *)&DataBuffer[6], bytes-24);        /*    for TDR format   */
         }

          checkFEE64DATAbuffer((char *)&DataBuffer[6], DataBuffer[5]);

      }

      printf ("reading data file terminated after %d blocks\n", blocks);

      fclose(InStream);

      printf ("processed %d items of which %d were good and %d had some fault\n",Items[8],GoodItems,Items[8]-GoodItems);
      printf ("ADC Data Items = %d \n", Items[0]);
      printf ("All Info Data Items = %d \n", Items[7]);
      printf ("Waveform Data Items = %d \n", Items[1]);
      printf ("Pause Info Data Items = %d \n", Items[2]);
      printf ("Resume Info Data Items = %d \n", Items[3]);
      printf ("SYNC100/WR Low Info Data Items = %d \n", Items[4]);
      printf ("WR High Info Data Items = %d \n", Items[5]);
      printf ("Discriminator Info Data Items = %d \n", Items[6]);


   exit(0);

   return(0);
}

void printbufferL(char* p, int l) 
{

    int len;
    int i, j;
    unsigned int * eventbuffer;

    len = l/4;                 /*   len in units of int  */
    eventbuffer = (unsigned  int *)p;

      printf("buffer len=%d bytes\n",l);
      printf(">\n");

  for (j=0;j<16;j++) {
    for (i=0;i<8;i++) {printf("0x%08lx ", *eventbuffer++);}
      printf("\n");
  }

}

void byteswop32(char* p, int l) 
{
    int len;
    char *ps;
    char *pd;
    char b0, b1, b2, b3;

   len = l/4;
   ps = p;
   pd = p;


   while (len > 0)
   {
       b0 = *ps++;
       b1 = *ps++;
       b2 = *ps++;
       b3 = *ps++;

       *pd++ = b3;
       *pd++ = b2;
       *pd++ = b1;
       *pd++ = b0;
   
       len--;
   }
}

void byteswop16(char* p, int l) 
{
    int len;
    char *ps;
    char *pd;
    char b0, b1;

   len = l/2;
   ps = p;
   pd = p;


   while (len > 0)
   {
       b0 = *ps++;
       b1 = *ps++;

       *pd++ = b1;
       *pd++ = b0;
   
       len--;
   }
}








