/********************************************************************/
/* Name        : TCP.h                                              */
/*                                                                  */
/* Author      : Frederic SAILLANT                                  */
/*                                                                  */
/* Last update : 23 fevrier 1998                                    */
/*                                                                  */
/* Purpose     : fichier include de definitions des prototypes des  */
/*               fonctions TCP/IP de base du GANIL                  */
/*                                                                  */
/********************************************************************/

#ifndef _TCP_H_
#define _TCP_H_

#define VRAI    1
#define FAUX    0
#define WINDOW  16384
#define USINMS  1000
#define SERVEUR 0
#define CLONE   1
#define CLIENT  2

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _TCPOPEN_
extern
#endif
int TcpOpen (int     *sid_pt,
             char     *ip_adrs,
             int     SourcePort, 
             int     DestPort, 
             long     timeout);

#ifndef _TCPREAD_
extern
#endif
int TcpRead (int     *sid_pt,
             char     *buffer,
             int    lg_buffer,
             int     *lg_recu_pt,
             long     timeout);

#ifndef _TCPWRITE_
extern
#endif
int TcpWrite(int     *sid_pt,
             char     *buffer,
             int     lg_buffer,
             int     *lg_ecrit_pt,
             long     timeout);

#ifndef _TCPCLOSE_
extern
#endif
int TcpClose(int     *sid_pt);

#ifdef __cplusplus
}
#endif

#endif /* _TCP_H_ */
