
/*
    This code completes the current data block and sends to the storage server

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

extern int Verbose;

extern int OutFlag;

extern int Waiting;

#define EXOGAM_END_BLOCK_TOKEN 0xff000000

void insert_block_header(int);
void insert_block_trailer(int);


extern unsigned short OutputBuffer[];
extern int Output_Buffer_Length;
extern int OutputBufferLen;             /*  units of short  */

extern int Block_Event_Count;
extern int Block_Sequence_Number;


/* --------------------------------------------------------------------- */

void insert_block_trailer(int datastream)
{

/*  insert data block terminator  */

    unsigned short * ptr1;
    unsigned int * ptr3;     /* for Exogam format */

    int j;

    if ((Verbose & 0x8000) == 0x8000) { printf("block_trailer %d  %d\n", Block_Event_Count, OutputBufferLen); }

/*    add end of block marker   */

            ptr1 = (unsigned short *)&OutputBuffer[OutputBufferLen];
 
            *ptr1++ = (unsigned short) (EXOGAM_END_BLOCK_TOKEN >> 16) & 0x0000ffff;
            *ptr1++ = (unsigned short) EXOGAM_END_BLOCK_TOKEN & 0x0000ffff;
            OutputBufferLen +=2;

/*    update some fields in the block header  */

            ptr1 = (unsigned short *) &OutputBuffer[11];
            ptr3 = (unsigned int *) &OutputBuffer[14];

            *ptr1 = Block_Event_Count;      /* block event count */
            *ptr3 = OutputBufferLen - 16 - 2;          /* actual data length in shorts */

/*
     printf("block_trailer >>>\n");
                for (j = 0; j <16;) {
                    printf(" 0x%04x", OutputBuffer[j]);
                    j++;
                    if ((j/8)*8 == j) printf("\n");
                 }
                 printf("\n");
*/

}

/* --------------------------------------------------------------------- */

void insert_block_header(int datastream)
{

/*    insert data block header  */

    unsigned short * ptr1;
    unsigned int * ptr3;     /* for Exogam format */
   int j;

    if ((Verbose & 0x8000) == 0x8000) { printf("block_header %d\n", Block_Sequence_Number); }

     Block_Event_Count = 0;
     OutputBufferLen = 0;

     ptr1 = (unsigned short *)&OutputBuffer[0];
     ptr3 = (unsigned int *) &OutputBuffer[4];

/*    add start of block marker   */

            memcpy (ptr1," EBYEDAT",8);              /* block type */

            *ptr3++ = Block_Sequence_Number;         /* block sequence number */
            Block_Sequence_Number++;

            *ptr3++ =  0x22061999;                    /* magic number */

            *ptr3++ =  0x0;                /* source id + destination id */

            *ptr3++ = Block_Event_Count;      /* block event count */
            *ptr3++ = 0;          /* checksum - omitted */
            *ptr3++ = 0;          /* data length */

     OutputBufferLen = 16;           /* length in shorts */

/*
     printf("block_header >>>\n");
                for (j = 0; j <16;) {
                    printf(" 0x%04x", OutputBuffer[j]);
                    j++;
                    if ((j/8)*8 == j) printf("\n");
                 }
                 printf("\n");
*/
}

/* --------------------------------------------------------------------- */

void xfer_block(int datastream)
{

   int s1;
   int len;
   int j;

   unsigned char * p8;
   unsigned short * p16;
   unsigned int * p32;

   int stream = 1;
 
/*    attempt to send data to tape server     */

      if (OutputBufferLen == 0) {        /* not started */
          insert_block_header(0);
      }  

      insert_block_trailer(0);

     len = OutputBufferLen << 1;

     if ((Verbose & 0x8000) == 0x8000) printf("xfer_block: for block of length %d bytes at Waiting=%d\n", len, Waiting);

              if ((Verbose & 0x8000) == 0x8000) {
                 printf("Output Block >>>\n");

                 p8  = (unsigned char *)&OutputBuffer[0];
                 p16 = (unsigned short *)&OutputBuffer[0];
                 p32 = (unsigned int *)&OutputBuffer[0];

                 for (j = 0; j <8; j++) {printf("%c", p8[j]);}
                 printf(": 0x%08x: 0x%08x: 0x%04x: 0x%04x: 0x%04x: 0x%04x: 0x%08x: 0x%08x\n",p32[2],p32[3],p16[8],p16[9],p16[10],p16[11],p32[6],p32[7]);

                 for (j = 0; j <64;) {
                    printf(" 0x%04x", p16[j]);
                    j++;
                    if ((j/8)*8 == j) printf("\n");
                 }
                 printf("\n");
              }

      if (OutFlag > 0) {
         s1 = GANILtransferTxData ((char *) OutputBuffer , stream, len); 
         if ((Verbose & 0x8000) == 0x8000) printf("xfer_block; GANILtransferTxData returned status = %d\n", s1);
      }

      Waiting = 0;

      insert_block_header(0);  /* start next buffer */

}

/* --------------------------------------------------------------------- */


