

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <unistd.h>


/*
    The procedures  signal_block   &   msgDefineMessage  are  called from the libxfer library  
      For this example code they can be noopos
*/

void signal_block ()  {}

int msgDefineMessage (u_int id, u_int xclass, u_int level, char *source, char *body) {

//  printf("id=%d, class=%d, level=%d, source=%s: %s\n",id, xclass, level, source, body);
  return 0;
}



void Usage(char *progname) {
    printf("Usage\n%s -n [server] -p [port] -f [file_name] -d [format] -t [ticks] -s [buffersize] -v [v]\n",progname);
    printf("\tserver is the IP address or name of server (default localhost)\n");
    printf("\tport is the base TCP port to use (default 10305)\n");
    printf("\tfile_name defines a file to be read for data rather than using internally generated data (default no file - use internal data)\n");
    printf("\tformat defines the data to be generated (default 0)\n");
    printf("\tticks is the delay between sending data blocks in millisecs (default 0)\n");
    printf("\tbuffersize is data block size in Kbytes (default 64)\n");
    printf("\tv is the setting for the verbose flag (default 0)\n");
    exit(1);
}
        
int main(int argc, char **argv) {

   int ID = 0;
   int IDs = 1;
   int id;

    char *TS_Server= (char*)"localhost";
    int Port=10305;

    int Format = 0;
    FILE *InStream;
    char *FileName= (char*)"f0.dat";
    char fname[32];
    int DelayTicks=0;     /* millisecs  */
    int NumBlocks=1;
    int verbose=0;
    int i, j;
    int BufferSize=64*1024;
    int rc;

      int rcode;
      pid_t pid;
      char p1[16];
      char p2[16];
      char p3[16];
      char p4[16];

    char sender_task[16] = "./DataSender";


    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
                    case 'i':
                        IDs = atoi(argv[++i]);
                        break;
                    case 'd':
                        Format = atoi(argv[++i]);
                        break;
                    case 'n':
                        TS_Server = argv[++i];
                        break;
                    case 'p':
                        Port = atoi(argv[++i]);
                        break;
                    case 't':
                        DelayTicks = atoi(argv[++i]);
                        break;
                    case 's':
                        BufferSize = atoi(argv[++i])*1024;
                        break;
                    case 'N':
                        NumBlocks = atoi(argv[++i]);
                        break;
                    case 'v':
                        verbose = 1;
                        break;
                    default:
                        Usage(argv[0]);
                        break;
                }
            }
            else
                Usage(argv[0]);
        }
    }

     for (id=ID; id<IDs; id++) {

//    check the file name

         sprintf(fname,"f%d.dat",id);
         InStream = fopen(fname,"r");
         if (InStream == NULL) {
           printf ("Unable to connect to data file\n");
           exit(16);
         }
         fclose(InStream);   /* will be reopened in the sender task */

//     start the sender task

                pid = fork();
                if (pid == -1)  {
                   printf("fork failed %d - This must be fixed - exiting.", errno);
                   exit(32);
                }
                if (pid == 0) {

//    this is the child process - use exec to overlay the driver code

                   sprintf(p1, "%d", id);
                   sprintf(p2, "%d", Port+id);
                   sprintf(p3, "%d", DelayTicks);
                   sprintf(p4, "%d", NumBlocks);
                   sprintf(fname,"f%d.dat",id);

                   rcode = execl(sender_task, sender_task, "-i", p1, "-p", p2, "-t", p3, "-N", p4, "-f", fname, NULL);

                   printf("Sender task %s returned %d - %s.", sender_task, errno, strerror(errno));

                   return;
                }

                printf("sender task has pid %d", pid);
    }

}
