

#    MIDAS Access Client  for the  DataAcquisition/Run Control service

package require MIDASAccessClient        ;#   load default support procedures

global MIDAS_DataAcquisitionControlClient_Exists
set MIDAS_DataAcquisitionControlClient_Exists 1

global MIDAS_RunControlClient_Exists
set MIDAS_RunControlClient_Exists 1

global DataAcquisitionControlServerHost DataAcquisitionControlServerPort

if {[info exists DataAcquisitionControlServerHost] == 0} then {set DataAcquisitionControlServerHost localhost}
if {[info exists DataAcquisitionControlServerPort] == 0} then {set DataAcquisitionControlServerPort 8015}

variable uri "urn:DataAcquisitionControlServer"
variable proxy "http://$DataAcquisitionControlServerHost:$DataAcquisitionControlServerPort/DataAcquisitionControlServer"

global DataAcquisitionControlClient__TimeOut
global DataAcquisitionControlClient__Debug

set DataAcquisitionControlClient__TimeOut 20000; # Not enough for LyrTech setup calls (see below)
set DataAcquisitionControlClient__Debug 0

set DataAcquisitionControlClient__LongTimeOut 120000
set DataAcquisitionControlClient__ShortTimeOut 1000

# proc insert-debug {s} {puts "$s"}

proc DataAcquisitionControlClient_Configure {} {
   global  DataAcquisitionControlServerHost DataAcquisitionControlServerPort
   variable proxy

   set proxy "http://$DataAcquisitionControlServerHost:$DataAcquisitionControlServerPort/DataAcquisitionControlServer"

   foreach method [info procs DataAcquisitionControlClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

      SOAP::create DataAcquisitionControlClient__GetState -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name GetState \
        -params {} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request
  
      SOAP::create DataAcquisitionControlClient__GetLastError -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name GetLastError \
        -params {} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

      SOAP::create DataAcquisitionControlClient__GetInformation -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name GetInformation \
        -params {} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

      SOAP::create DataAcquisitionControlClient__DoReset -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name DoReset \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply  \

      SOAP::create DataAcquisitionControlClient__DoSetUp -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__LongTimeOut \
        -name DoSetUp \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

      SOAP::create DataAcquisitionControlClient__DoStop -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name DoStop \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

      SOAP::create DataAcquisitionControlClient__DoGo -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name DoGo \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

      SOAP::create DataAcquisitionControlClient__DoOption -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__LongTimeOut \
        -name DoOption \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

      SOAP::create DataAcquisitionControlClient__GetOption -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__LongTimeOut \
        -name GetOption \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

      SOAP::create DataAcquisitionControlClient__GetCounters -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name GetCounters \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

      SOAP::create DataAcquisitionControlClient__GetRates -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__TimeOut \
        -name GetRates \
        -params {Parameter string} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request  \

      SOAP::create DataAcquisitionControlClient__ServerVerbose -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__ShortTimeOut \
        -name ServerVerbose \
        -params {opt int} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

      SOAP::create DataAcquisitionControlClient__ServerImplementation -proxy $proxy -uri $uri \
        -timeout $DataAcquisitionControlClient__ShortTimeOut \
        -name ServerImplementation \
        -params {opt int} \
        -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
        -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

package provide DataAcquisitionControlClient 1.0
package provide RunControlClient 1.0

puts "RunControlClient provided"
puts "DataAcquisitionControlClient"

