


# variable Started 0

if {![info exists Started]} {variable Started 0}
if {![info exists Reloading]} {variable Reloading 0}

if {$Started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    
    if {$Reloading == 1} {
        set Reloading 0
        global env
        set z [catch {source [file join $env(MIDASBASE) TclHttpd Html Spectrum analysis.tcl]} m]
        if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}
    }

}

if {$Started == 0} {           ;#  first time load code and define local variables

#    global MIDAS_SpectrumAccessServer_Exists
#    if {![info exists MIDAS_SpectrumAccessServer_Exists]} then {

       set z [catch {package require SpectrumClient} m]
       if {$z != 0} {puts "SpectrumClient returned z=$z and $m"}
#    }

     global env
     set z [catch {source [file join $env(MIDASBASE) TclHttpd Html Spectrum analysis.tcl]} m]
     if {$z != 0} {puts "analysis.tcl returned z=$z and $m"}

    set Started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable MemSas 0
    variable DiscSas 0
    global MemSasAccess_Exists
    if {[info exists MemSasAccess_Exists]}  {set MemSas 1}
    global DiscSasAccess_Exists
    if {[info exists DiscSasAccess_Exists]} {set DiscSas 1}

    if {$MemSas == 0 && $DiscSas == 0} {set MemSas 1}
    
    if {$DiscSas == 1} {
        namespace eval ::DataAcquisition {
            variable ACQSERVERS; set ACQSERVERS [list localhost]
            variable ACQSERVER; set ACQSERVER [lindex $ACQSERVERS 0]
        }
    }

    variable AUTORATE 8000
    variable AUTOMODE "OFF"
    variable AUTOSTATE 0

    variable OPT "NULL"
    
    global tcl_platform
    if {$tcl_platform(platform) == "unix"} {
        if {$DiscSas == 1} {
            variable DirName "/MIDAS/SpecData"
        } else {
            variable DirName "/MIDAS/SpecData"
        }
    } else {
        if {$DiscSas == 1} {
            variable DirName "c:/MIDAS/SpecData"
        } else {
            variable DirName "c:/MIDAS/SpecData"
        }
    }

#    global variables 
    
    variable MaxGalleries 30
    if {[info exists My_MaxGalleries]} {set MaxGalleries $My_MaxGalleries}
    variable MAXOVERLAPS
    variable MaxOverlaps 8      ;#  per gallery
    if {[info exists My_MaxOverlaps]} {set MaxOverlaps $My_MaxOverlaps}
    variable MaxTags 50         ;#  per gallery
    if {[info exists My_MaxTags]} {set MaxTags $My_MaxTags}
    variable MaxFits 8          ;#  per gallery
    if {[info exists My_MaxFits]} {set MaxFits $My_MaxFits}

    variable numgallery 1
    variable numoverlap $MaxOverlaps

    variable layout 1
    
    variable currentgallery 1
    variable currentoverlap 1      ;# within current gallery

    variable mode1 0
    variable mode1list
    set mode1list [list new add overlap]
    variable mode2 0
    variable mode2list
    set mode2list [list current all]
    variable mode3 0
    variable mode3list
    set mode3list [list linear log]

    variable selectlist
    set selectlist [list x y xy]
    variable SelectionMode
    set SelectionMode 0
    
    variable multimodelist [list single multi]
    variable multimode "single"

    variable Colors          ;#  there are $MaxTags Colors
    variable ColorScheme 0

        set Colors(Black) rgb(0,0,0)
        set Colors(White) rgb(255,255,255)

        if {$ColorScheme == 0} {
    
            set Colors(1) rgb(0,0,255)   ;# blue
            set Colors(2) rgb(0,255,0)   ;# green
            set Colors(3) rgb(255,165,0) ;# orange
            set Colors(4) rgb(255,0,255) ;# magenta
            set Colors(5) rgb(0,255,255) ;# cyan
            set Colors(6) rgb(255,255,0) ;# yellow
            set Colors(7) rgb(128,0,128)   ;# purple
            set Colors(9) rgb(0,128,128) ;# dark green
            set Colors(8) rgb(0,0,0)   ;# black
            set Colors(10) rgb(128,128,0) ;# olive

            set Colors(ActiveGallery) $Colors(Black)  
            set Colors(InActiveGallery) rgb(128,128,128)   ;# grey
            set Colors(Crosshair) $Colors(Black)  
            set Colors(Tag) rgb(255,0,0)   ;# red
            set Colors(ActiveSelection) rgb(0,255,0)   ;# green
            set Colors(InActiveSelection) rgb(255,0,0)   ;# red
            set Colors(Label)  $Colors(Black) 
            set Colors(GalleryBg) White
    
        } else {
    
            set Colors(1) rgb(255,255,0)   ;# !blue
            set Colors(2) rgb(255,0,255)   ;# !green
            set Colors(3) rgb(0,90,255) ;# !orange
            set Colors(4) rgb(0,255,0) ;# !magenta
            set Colors(5) rgb(255,0,0) ;# !cyan
            set Colors(6) rgb(0,0,255) ;# !yellow
            set Colors(7) rgb(128,255,128)   ;# !purple
            set Colors(9) rgb(255,128,128) ;# !dark green
            set Colors(8) rgb(255,255,255)   ;# white
            set Colors(10) rgb(128,128,255) ;# !olive

            set Colors(ActiveGallery) $Colors(White) 
            set Colors(InActiveGallery) rgb(128,128,128)   ;# grey
            set Colors(Crosshair) $Colors(White) 
            set Colors(Tag) rgb(255,0,0)   ;# red
            set Colors(ActiveSelection) rgb(0,255,0)   ;# green
            set Colors(InActiveSelection) rgb(255,0,0)   ;# red
            set Colors(Label)  $Colors(White) 
            set Colors(GalleryBg) Black
        }

    variable MAXCOLOURS
    variable CM
    variable CMpalettemenu
    variable CMpalette

    set MAXCOLOURS 32

    set CMpalettemenu [list current]
    set CMpalette current

    set CM(current) [list \
       #d0d0d0 #0000ff #002aff #0055ff #007fff #00aaff #00d4ff #00ffff \
       #00ffd5 #00ffaa #00ff80 #00ff55 #00ff2b #00ff00 #2ad500 #55aa00 \
       #7f8000 #aa5500 #d42b00 #ff0000 #ff2a00 #ff5500 #ff7f00 #ffaa00 \
       #ffd400 #ffff00 #ffff2a #ffff55 #ffff7f #ffffaa #ffffd4 #ffffff \
    ]

    set MAXOVERLAPS 8
    set OLCMpalette current

    set OLCM(current) [list black red blue green yellow magenta cyan white]

    variable MAXCONTOURS 
    set MAXCONTOURS 32

    variable SDCbase
    set SDCbase 2
    variable SDCmodes [list linear log meis]
    variable SDCmode
    set SDCmode [first $SDCmodes]
    variable SDC
    for {set i 0} {$i < $MAXCONTOURS} {incr i} {set SDC(c$i) [expr $SDCbase * $i]}

    variable Swatch
    set Swatch 0
     

#    define control variables of the form Var(gallery,tag)

    variable dbtagx     ;# 1d channel ;  2d x coord
    variable dbtagy     ;# 1d counts  ;  2d y coord
    variable dbtagz     ;# 1d unused  ;   2d counts

    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxTags} {incr j} {
            set dbtagx($i,$j) 0
            set dbtagy($i,$j) 0
            set dbtagz($i,$j) 0
    }  }
    
#    define control variables of the form Var(gallery,fit)

    variable dbfit
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxFits} {incr j} {
            set dbfit($i,$j) ""
    }  }
    
#    define control variables of the form Var(gallery,overlay)

    variable dbInUse
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbInUse($i,$j) 0
    }  }

   variable dbSpecName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecName($i,$j) "undefined"
    }  }

    variable dbServerName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbServerName($i,$j) "undefined"
    }  }

    variable dbSpecPathName
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecPathName($i,$j) "undefined"
    }  }
    
    variable dbSpecRawData
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRawData($i,$j) {}
    }  }
    
    variable dbSpecData
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecData($i,$j) ""
    }  }

    variable dbSpecTitle
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecTitle($i,$j) ""
    }  }

    variable dbSpecDim
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbSpecDim($i) 1
    }
    
    variable dbXMin
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbXMin($i) 0
    }
    
    variable dbXMax
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbXMax($i) 65535
    }
    
    variable dbYMin
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbYMin($i) 0
    }
    
    variable dbYMax
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
            set dbYMax($i) 255
    }

    variable dbSpecBase0
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecBase0($i,$j) 0
    }  }
    
    variable dbSpecRange0
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRange0($i,$j) 65535
    }  }

    variable dbSpecBase1
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecBase1($i,$j) 0
    }  }
    
    variable dbSpecRange1
    for {set i 1} {$i <= $MaxGalleries} {incr i} {
        for {set j 1} {$j <= $MaxOverlaps} {incr j} {
            set dbSpecRange1($i,$j) 255
    }  }

    variable Compression 1
    variable SpecCont ""
    variable SpecLength ""
    variable DataLength ""
    variable SpectrumList {}
    variable DirectoryList {}
    variable SpecDim 1
    variable SpecB 0
    variable SpecR 0
    variable SpecArgs {}
    variable DataList {}
    variable CustomYView 0
    variable SpecSize 0
    variable SpecLimit 0
    variable WindowSize 0
    variable WindowSizeX 0
    variable WindowSizeY 0
    variable Skip0 0
    variable QuikLoad 0
    variable DefCont 0
    variable SpecShow 0
    variable Showing 0
    variable Reloading 0

proc  do_configure {} {}
    
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }
    
    proc dbReset {{gallery 1} {overlap 1}} {
       upvar #1 dbSpecName($gallery,$overlap) SpecName
       upvar #1 dbServerName($gallery,$overlap) ServerName
       upvar #1 dbSpecTitle($gallery,$overlap) SpecTitle
       upvar #1 dbSpecPathName($gallery,$overlap) SpecPathName
       upvar #1 dbSpecRawData($gallery,$overlap) SpecRawData
       upvar #1 dbSpecData($gallery,$overlap) SpecData
       upvar #1 dbXMin($gallery) XMin
       upvar #1 dbXMax($gallery) XMax
       upvar #1 dbYMin($gallery) YMin
       upvar #1 dbYMax($gallery) YMax
       upvar #1 dbSpecBase0($gallery,$overlap) SpecBase0
       upvar #1 dbSpecRange0($gallery,$overlap) SpecRange0
       upvar #1 dbSpecBase1($gallery,$overlap) SpecBase1
       upvar #1 dbSpecRange1($gallery,$overlap) SpecRange1
       
       set SpecName "undefined"
       set SpecTitle ""
       set SpecPathName "undefined"
       set SpecRawData {}
       set SpecData ""
       set XMin 0
       set XMax 65535
       set YMin 0
       set YMax 255
       set SpecBase0 0
       set SpecRange0 65535
       set SpecBase1 0
       set SpecRange1 255
    }
    
    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag
        variable MemSas
        variable DiscSas
        variable DirName
        
        variable MaxGalleries 
        variable MaxOverlaps 
        variable MaxTags
        
        variable numgallery
        variable numoverlap
        
       variable currentgallery
       variable currentoverlap

       variable mode1
       variable mode2
       variable mode3
       variable multimode
       variable ColorScheme
       variable CustomYView
       variable SelectionMode

       variable SpecShow
       variable Showing

       variable OPT
       variable CMpalette
       variable Swatch
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       upvar #1 dbYMin($currentgallery) YMin
       upvar #1 dbYMax($currentgallery) YMax
       
	upvar #1 dbSpecName($currentgallery,$currentoverlap) SpecName
	upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName
	upvar #1 dbSpecTitle($currentgallery,$currentoverlap) SpecTitle
       
       upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
       upvar #1 dbSpecData($currentgallery,$currentoverlap) SpecData
       
       upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
       upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
       upvar #1 dbSpecBase1($currentgallery,$currentoverlap) SpecBase1
       upvar #1 dbSpecRange1($currentgallery,$currentoverlap) SpecRange1
       
       variable dbInUse
       variable dbSpecName
       variable dbServerName
       variable dbSpecTitle
       variable dbSpecPathName
       variable dbtagx
       variable dbtagy
       variable dbtagz
       variable dbSpecDim
       variable dbSpecBase0
       variable dbSpecRange0
       variable dbSpecBase1
       variable dbSpecRange1

    variable AUTORATE
    variable AUTOMODE

       global MIDAS_SpectrumAccessServer_Exists
       global SpectrumServerHost

       InsertLog "AcqServers=$::DataAcquisition::ACQSERVERS"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "MemSas=$MemSas; DiscSas=$DiscSas"
         InsertLog "DirName=$DirName; SpecName=$SpecName; SpecTitle=$SpecTitle"
         InsertLog "AUTOMODE=$AUTOMODE; AUTORATE=$AUTORATE"
         InsertLog "Spectrum=[SpectrumName]"
         InsertLog "Spectrum Reference=[SpectrumReference]"
         InsertLog "SpecTitle=[SpectrumTitle]"
         InsertLog "SpecShow=$SpecShow; Showing=$Showing"
         InsertLog "OPT = $OPT; CMpalette=$CMpalette; Swatch=$Swatch"
         
         InsertLog "numgallery=$numgallery; currentgallery=$currentgallery; currentoverlap=$currentoverlap"
         InsertLog "mode1=$mode1; mode2=$mode2; mode3=$mode3; multimode=$multimode; ColorScheme=$ColorScheme; CustomYView=$CustomYView; SelectionMode=$SelectionMode"

         InsertLog "$XMin $XMax $YMin $YMax"
         InsertLog "$SpecBase0 $SpecBase1 $SpecRange0 $SpecRange1"
         
       for {set g 1} {$g<=$MaxGalleries} {incr g} {
          if {$dbInUse($g,1) == 0} {continue}
          for {set o 1} {$o <= $MaxOverlaps} {incr o} {
             if {$dbInUse($g,$o) == 0}  {continue}
             InsertLog "gallery $g overlap $o in use [SpectrumName $g $o] :$dbServerName($g,$o):$dbSpecName($g,$o):$dbSpecDim($g):$dbSpecBase0($g,$o):$dbSpecRange0($g,$o):$dbSpecBase1($g,$o):$dbSpecRange1($g,$o):$dbSpecTitle($g,$o):$dbSpecPathName($g,$o):"
          }
       }
       
       for {set g 1} {$g <= $MaxGalleries} {incr g} {
         if {$dbInUse($g,1) == 0} {continue}
         for {set t 1} {$t <= $MaxTags} {incr t} {
             if {$dbtagx($g,$t) == 0} {continue}
             InsertLog "gallery $g tag $t in use  : $dbtagx($g,$t) $dbtagy($g,$t) $dbtagz($g,$t)"
         }
       }

       if {[info exists MIDAS_SpectrumAccessServer_Exists]} then {
         InsertLog "MIDAS_SpectrumAccessServer_Exists = $MIDAS_SpectrumAccessServer_Exists"
       }

       if {[info exists SpectrumServerHost]} then {
         InsertLog "SpectrumServerHost = $SpectrumServerHost"
       }

          InsertLog "&&&&&&SpecData"
          InsertLog "$SpecData"

          InsertLog "&&&&&&SpecRawData"
          InsertLog "$SpecRawData"
    }
    
  proc do_galleries {vl} {
    variable numgallery
    variable MaxGalleries

    switch $vl {
        1 {set numgallery $vl}    
        2 {set numgallery $vl}    
        4 {set numgallery $vl}
        6 {set numgallery $vl}
        9 {set numgallery $vl}
       16 {set numgallery $vl}
       30 {set numgallery $vl}
        default {}
    }

    if {$numgallery > $MaxGalleries} {set numgallery $MaxGalleries}
 }

  proc do_canvas {g x y} {
     variable MaxGalleries
     variable currentgallery
     variable currentoverlap
     variable pxsize
     variable pysize
     variable Swatch

     if {$g < $MaxGalleries} {   ;# click on a 2d comvas

        set currentgallery $g
        set currentoverlap 1
        do_push2dtag [expr $x/$pxsize] [expr $y/$pysize]

     } else {    ;#  click on a colour swatch

       set Swatch [expr $g - $MaxGalleries]

     }
 }

  proc do_layouts {vl} {
    variable layout

    set layout $vl
 }
    
 proc SpecCopy {spec path base0 range0 base1 range1 type title counts} {
    global tcl_platform

      set z1 [catch {open $path w} m1]

      if {$tcl_platform(platform) != "windows"} {
           set z2 [catch {file attributes $path -permissions rwxrwxrwx} m2]
      } else {set z2 0}

      if {$z1 != 0} then {
          puts "Cannot create $path - $m1"
      }
      if {$z2 != 0} then {
          puts "error accessing $path - $m2"
      }

      set f $m1

      fconfigure $f -translation binary -encoding binary

  set ctime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]
  set mtime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]

      puts -nonewline $f [binary format i1 412900921]   ;#   magic number
      puts -nonewline $f [binary format i1 1]           ;#   version
      puts -nonewline $f [binary format a32 $spec]      ;#   spectrum name
      puts -nonewline $f [binary format i1 1]           ;#   dimension
      puts -nonewline $f [binary format a20 $ctime]     ;#   creation time/date
      puts -nonewline $f [binary format a20 $mtime]     ;#   modification time/date
      puts -nonewline $f [binary format i1 $base0]      ;#   base0
      puts -nonewline $f [binary format i1 $base1]      ;#   base1

      for {set i 3} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   baseI
      }

      puts -nonewline $f [binary format i1 $range0]     ;#   range0
      puts -nonewline $f [binary format i1 $range1]     ;#   range1

      for {set i 3} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   rangeI
      }

      puts -nonewline $f [binary format i1 -1]        ;#   spectrum title offset

      for {set i 2} {$i <=32} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  information pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  annotation pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  calibration pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  efficiency pointers
      }

                                                     ;#  data array 1 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]        ;#  array type  (32 bit unsigned)
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 0]        ;#  spectrum counts offset

                                                     ;#  data array 2 descriptor 
      puts -nonewline $f [binary format i1 0]       ;#  array layout
      puts -nonewline $f [binary format i1 $type]       ;#  array type 
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 -1]       ;#  spectrum counts offset

      puts -nonewline $f [binary format i1 436]      ;#  base of string space
      puts -nonewline $f [binary format i1 20]       ;#  string free space
      puts -nonewline $f [binary format i1 76]       ;#  top of string space

      puts -nonewline $f [binary format i1 512]      ;#  base of counts space
      puts -nonewline $f [binary format i1 $range0]       ;#  string free space
      puts -nonewline $f [binary format i1 $range0]       ;#  top of string space
 
      puts -nonewline $f [binary format a20 $title]     ;# string space - title

      for {set i 456} {$i < 512} {incr i} {
         puts -nonewline $f [binary format c1 0]       ;#  unused
      }

      puts -nonewline $f [binary format i* $counts]      ;# counts

      close $f
}

    
    proc ServerName {{gallery 0} {overlap 0}} {
        variable DiscSas

      if {$DiscSas == 1} {return ""}
      if {[llength $::DataAcquisition::ACQSERVERS] <= 1} {return ""}

      if {$gallery == 0 || $overlap == 0} {
           variable currentgallery
           variable currentoverlap
           upvar #1 dbServerName($currentgallery,$currentoverlap) SName
      } else {
           upvar #1 dbServerName($gallery,$overlap) SName
      }

       return $SName
    }

    proc SpectrumName {{gallery 0} {overlap 0}} {
        variable MemSas
        variable DiscSas
        variable DirName

      if {$gallery == 0 || $overlap == 0} {
           variable currentgallery
           variable currentoverlap
           upvar #1 dbSpecName($currentgallery,$currentoverlap) SpecName
      } else {
           upvar #1 dbSpecName($gallery,$overlap) SpecName
      }
        
        if {$MemSas == 1} {return $SpecName}
        if {$DiscSas == 1} {return [file join $DirName $SpecName]}
    }
    
    proc SpectrumTitle {{gallery 0} {overlap 0}} {
        variable DirName

      if {$gallery == 0 || $overlap == 0} {
           variable currentgallery
           variable currentoverlap
           upvar #1 dbSpecTitle($currentgallery,$currentoverlap) SpecTitle
      } else {
           upvar #1 dbSpecTitle($gallery,$overlap) SpecTitle
      }
        
        return $SpecTitle
    }

proc midas-check-for-temp {} {
  global env
   if {[file exists $env(MIDASTempDir)] == 0} then {
      InsertLog "Temporary file directory $env(MIDASTempDir) does not exist\n\
        You can set the environment variable MIDASTempDir to define an alternative location"
      return 0
   } else {
      catch {:file mkdir [file join $env(MIDASTempDir) tcl[pid]]}
      cd [file join $env(MIDASTempDir) tcl[pid]]
      return 1
   }
}

    proc load_spectrum {s {gallery 0} {overlap 0}} {
        global env
        global SpectrumServerHost
        variable DiscSas
        variable QuikLoad
        
      if {$gallery == 0 || $overlap == 0} {
           variable currentgallery
           variable currentoverlap
	   upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName

           upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
           upvar #1 dbSpecTitle($currentgallery,$currentoverlap) SpecTitle

           upvar #1 dbSpecDim($currentgallery) SpecDim
           upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
           upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
           upvar #1 dbSpecBase1($currentgallery,$currentoverlap) SpecBase1
           upvar #1 dbSpecRange1($currentgallery,$currentoverlap) SpecRange1
      } else {
  	   upvar #1 dbServerName($gallery,$overlap) ServerName

           upvar #1 dbSpecRawData($gallery,$overlap) SpecRawData
           upvar #1 dbSpecTitle($gallery,$overlap) SpecTitle

           upvar #1 dbSpecDim($gallery) SpecDim
           upvar #1 dbSpecBase0($gallery,$overlap) SpecBase0
           upvar #1 dbSpecRange0($gallery,$overlap) SpecRange0
           upvar #1 dbSpecBase1($gallery,$overlap) SpecBase1
           upvar #1 dbSpecRange1($gallery,$overlap) SpecRange1
      }

       if {$DiscSas == 1} {return $s}   ;#  already a disc PATH name

#    for a MemSas based spectrum we have to copy to a temp file

       if {$QuikLoad == 1} {return "NULL"}

#    check for and if necessary create a temporary directory

       if {[midas-check-for-temp] == 0} {return -1}

       set to [file join $env(MIDASTempDir) [set ServerName]_[set s].msf]

       set z [catch {file delete -force $to}]   ;#  in case already exists

       switch $SpecDim {
         1   {
              set z [catch {SpecCopy $s $to  $SpecBase0 $SpecRange0 0 0 5 $SpecTitle $SpecRawData} m]
              if {$z!=0} then {
                 InsertLog "Error attempting to copy spectrum $s: $m"
                 return "null"
              }
         }
         2   {
              set z [catch {SpecCopy $s $to  $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 5 $SpecTitle $SpecRawData} m]
              if {$z!=0} then {
                 InsertLog "Error attempting to copy spectrum $s: $m"
                 return "null"
              }
         }
       }
       
       return $to
    }

   proc do_show_1d {} {
       variable currentgallery
       variable currentoverlap
       
       upvar #1 dbSpecData($currentgallery,$currentoverlap) SpecData
       upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
       upvar #1 dbSpecDim($currentgallery) SpecDim
       upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
       upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       upvar #1 dbYMin($currentgallery) YMin
       upvar #1 dbYMax($currentgallery) YMax

       variable Compression
       variable SpecLength
       
       variable mode3
       variable mode3list

       variable SpecLimit
       variable WindowSize
       variable Skip0
       variable CustomYView
       variable Showing
       variable SpecShow

           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim in do_show_1d; internal logic error"; return}

           if {$XMin < $SpecBase0} {set XMin $SpecBase0}
           if {$XMin == $SpecBase0 && $Skip0 > 0} {set XMin [expr $SpecBase0 + 2]}
           if {$XMax <= $XMin} {set XMax $SpecRange0}
           if {$XMax >= $SpecRange0} {set XMax [expr $SpecRange0 - 1]}

           set SpecLength [expr $XMax - $XMin + 1]
           set WindowSize [expr $XMax - $XMin + 1]
           set Compression [expr max(1, $SpecLength / 1024)]
       
           set ymin 0
           set ymax 0
           set SpecData ""
           set k $XMin
           for {set i $XMin} {$i <= $XMax} {} {
              set item 0
              for {set j 0} {$j < $Compression} {incr j} {
                 switch [lindex $mode3list $mode3] {
                     linear  {set dword [lindex $SpecRawData $i]}
                     log     {
                         set d [expr [lindex $SpecRawData $i] & 0x00000000ffffffff]
                         if {$d <= 0} {set dword 0} else {set dword [expr log($d)]}
                     }
                 }
                 if {$dword > $item} {set item $dword}
                 incr i
                 if {$i > $XMax} {break}
              }
              if {$item > $ymax} {set ymax $item}
              if {$item < $ymin} {set ymin $item}
              append SpecData "\[[expr $k],$item\],"
              incr k $Compression
           }
           
           if {$CustomYView == 0} {
               set YMin [expr (round ($ymin*9)/10)]
               set YMax [expr (round ($ymax*11)/10)]
           }
           
           set SpecLimit $ymax
              
       set SpecShow 1
       set Showing 1
   }

   proc do_show_2d {} {
       variable currentgallery
       variable currentoverlap
       
       upvar #1 dbSpecData($currentgallery,$currentoverlap) SpecData
       upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
       upvar #1 dbSpecDim($currentgallery) SpecDim
       upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
       upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
       upvar #1 dbSpecBase1($currentgallery,$currentoverlap) SpecBase1
       upvar #1 dbSpecRange1($currentgallery,$currentoverlap) SpecRange1
       
       upvar #1 dbXMin($currentgallery) XMin
       upvar #1 dbXMax($currentgallery) XMax
       upvar #1 dbYMin($currentgallery) YMin
       upvar #1 dbYMax($currentgallery) YMax

       variable Compression
       variable SpecLength

       variable SpecLimit
       variable WindowSizeX
       variable WindowSizeY
       variable CustomYView
       variable Showing
       variable SpecShow

           if {$SpecDim != 2} {InsertLog "Spectrum Dimension is $SpecDim in do_show_2d; internal logic error"; return}

           if {$XMin < $SpecBase0} {set XMin $SpecBase0}
#           if {$XMax <= $XMin} {set XMax $SpecRange0}
           if {$XMax >= $SpecRange0} {set XMax [expr $SpecRange0 - 1]}

           if {$YMin < $SpecBase1} {set YMin $SpecBase1}
#           if {$YMax <= $YMin} {set YMax $SpecRange1}
           if {$YMax >= $SpecRange1} {set YMax [expr $SpecRange1 - 1]}

           set SpecLength [expr $XMax - $XMin + 1]
           set WindowSizeX [expr $XMax - $XMin + 1]
           set WindowSizeY [expr $YMax - $YMin + 1]

           set ymin 0
           set ymax 0
       
           set SpecData ""
           set k 0
           for {set i $XMin} {$i <= $XMax} {incr i} {
              for {set j $YMin} {$j <= $YMax} {incr j} {

                  set dword [lindex $SpecRawData $k]
                  incr k

                  set item $dword

                  if {$item > $ymax} {set ymax $item}
                  if {$item < $ymin} {set ymin $item}
                  append SpecData "$item "
              }
           }
           
#           if {$CustomYView == 0} {
#               set YMin [expr (round ($YMin*9)/10)]
#               set YMax [expr (round ($YMax*11)/10)]
#           }
           
           set SpecLimit $ymax
              
       set SpecShow 2
       set Showing 1

   }

    proc do_show {} {
       variable currentgallery
       variable currentoverlap
       variable numgallery
       variable numoverlap
       variable dbInUse
       variable mode2

       set gBAK $currentgallery
       set oBAK $currentoverlap
       
       for {set g 1} {$g<=$numgallery} {incr g} {
          for {set o 1} {$o<=$numoverlap} {incr o} {
             if {$dbInUse($g,$o) == 1} {
                if {$mode2 == 0} {     ;#  mode is current 
                    if {$g != $gBAK || $o != $oBAK} {continue}
                }

                set currentgallery $g
                set currentoverlap $o

                upvar #1 dbSpecDim($currentgallery) SpecDim
                upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName

	        set ::DataAcquisition::ACQSERVER $ServerName

                switch $SpecDim {
                    1  {do_show_1d}
                    2  {do_show_2d}
                    default {InsertLog "Spectrum Dimension is $SpecDim; only 1d & 2d supported"}
                }
             }
          }
       }

       set currentgallery $gBAK
       set currentoverlay $oBAK
   }

   proc do_loadSpectrum {} {
       variable currentgallery
       variable currentoverlap
       
       upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName
       upvar #1 dbSpecPathName($currentgallery,$currentoverlap) SpecPathName
       upvar #1 dbSpecTitle($currentgallery,$currentoverlap) SpecTitle
       upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
       upvar #1 dbSpecDim($currentgallery) SpecDim
       upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
       upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
       upvar #1 dbSpecBase1($currentgallery,$currentoverlap) SpecBase1
       upvar #1 dbSpecRange1($currentgallery,$currentoverlap) SpecRange1

	        set ::DataAcquisition::ACQSERVER $ServerName

       set m [do_details 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set details [second $m]

       set SpecDim [first $details]

       if {$SpecDim == 1} {
           set SpecBase0 [second $details]
           set SpecRange0 [third $details]
       }

       if {$SpecDim == 2} {
           set SpecBase0 [first [second $details]]
           set SpecBase1 [second [second $details]]
           set SpecRange0 [first [third $details]]
           set SpecRange1 [second [third $details]]
       }

       set m [do_title 1]
       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecTitle [second $m]

       if {$SpecDim == 1} {
           set m [do_read1D [SpectrumName $currentgallery $currentoverlap] $SpecBase0 $SpecRange0 1]
       }

       if {$SpecDim == 2} {
           set m [do_read2D [SpectrumName $currentgallery $currentoverlap] $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 1 1]
       }

       if {[first $m] != 0} {return}    ;#   error already reported
       set SpecRawData [second $m]

       set SpecPathName [load_spectrum [SpectrumName $currentgallery $currentoverlap]]

   }

    proc do_updateSpectrum {} {
	variable currentgallery
	variable currentoverlap
	
	upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName
	upvar #1 dbSpecPathName($currentgallery,$currentoverlap) SpecPathName
	upvar #1 dbSpecTitle($currentgallery,$currentoverlap) SpecTitle
	upvar #1 dbSpecRawData($currentgallery,$currentoverlap) SpecRawData
	upvar #1 dbSpecDim($currentgallery) SpecDim
	upvar #1 dbSpecBase0($currentgallery,$currentoverlap) SpecBase0
	upvar #1 dbSpecRange0($currentgallery,$currentoverlap) SpecRange0
	upvar #1 dbSpecBase1($currentgallery,$currentoverlap) SpecBase1
	upvar #1 dbSpecRange1($currentgallery,$currentoverlap) SpecRange1
	
	variable MaxTags

	set ::DataAcquisition::ACQSERVER $ServerName
	
	if {$SpecDim == 1} {
	    set m [do_read1D [SpectrumName $currentgallery $currentoverlap] $SpecBase0 $SpecRange0 1]
	}
	
	if {$SpecDim == 2} {
	    set m [do_read2D [SpectrumName $currentgallery $currentoverlap] $SpecBase0 $SpecRange0 $SpecBase1 $SpecRange1 1 1]
	}
	
	if {[first $m] != 0} {return}    ;#   error already reported
	set SpecRawData [second $m]
	
	for {set i 1} {$i<=$MaxTags} {incr i} {
	    upvar #1 dbtagx($currentgallery,$i) tagx
	    upvar #1 dbtagy($currentgallery,$i) tagy
	    if {$tagx != 0} {set tagy [lindex $SpecRawData $tagx]}
	}
	
	set SpecPathName [load_spectrum [SpectrumName $currentgallery $currentoverlap] $currentgallery $currentoverlap]
	
    }

    proc do_updateSpectra {} {
       variable currentgallery
       variable currentoverlap
       variable numgallery
       variable numoverlap
       variable dbInUse

       set gBAK $currentgallery
       set oBAK $currentoverlap
       
       for {set g 1} {$g<=$numgallery} {incr g} {
          for {set o 1} {$o<=$numoverlap} {incr o} {
             if {$dbInUse($g,$o) == 1} {

                set currentgallery $g
                set currentoverlap $o

                do_updateSpectrum
             }
          }
       }

       set currentgallery $gBAK
       set currentoverlay $oBAK
    }

    proc do_update {} {
        variable mode2

        if {$mode2 == 0} {do_updateSpectrum} else {do_updateSpectra}
    }
    
    proc RemoveAllSpectra {} {
	variable currentgallery
	variable currentoverlap
	variable numgallery
	variable numoverlap
	variable dbInUse
       variable MaxTags
       variable dbtagx
       variable dbtagy
	
	for {set g 1} {$g <= $numgallery} {incr g} {
	    for {set o 1} {$o <= $numoverlap} {incr o} {
		if {$dbInUse($g,$o) == 1} {set dbInUse($g,$o) 0}
	    }
	}
        for {set j 1} {$j <= $MaxTags} {incr j} {
            if {$dbtagx($g,$j) == 0} {continue}
            set dbtagx($g,$j) 0; set dbtagy($g,$) 0
        }
	set currentgallery 1
	set currentoverlap 1
    }
    
    proc SelectSpectrum {s} {
        global SpectrumServerHost
	variable currentgallery
	variable currentoverlap
	variable numgallery
	variable numoverlap
	variable dbInUse
	
	variable mode1
	variable mode1list
	variable multimode
	
	switch [lindex $mode1list $mode1] {
	    
	    new {
		switch $multimode {
		    single {
			set gallery $currentgallery; set overlap 1
			if {$gallery == 0} {set gallery 1}
			set dbInUse($gallery,$overlap) 1
			dbReset $gallery $overlap
		    }
		    multi {
			for {set g 1} {$g <= [expr $numgallery+1]} {incr g} {
			    if {$g > $numgallery} {InsertLog "All galleries in use"; return}
			    set gallery $g; set overlap 1
			    if {$dbInUse($gallery,$overlap) == 0} {
				set dbInUse($gallery,$overlap) 1
				dbReset $gallery $overlap
				break
			    }
			}                
		    }
		}
	    }
	    add {
		for {set g 1} {$g <= [expr $numgallery+1]} {incr g} {
		    if {$g > $numgallery} {InsertLog "All galleries in use"; return}
		    set gallery $g; set overlap 1
		    if {$dbInUse($gallery,$overlap) == 0} {
			set dbInUse($gallery,$overlap) 1
			dbReset $gallery $overlap
			break
		    }
		}
	    }
	    overlap {
		set gallery $currentgallery
		for {set o 1} {$o <= [expr $numoverlap+1]} {incr o} {
		    if {$o > $numoverlap} {InsertLog "All overlaps in use"; return}
		    if {$dbInUse($gallery,$o) == 0} {
			set overlap $o
			set dbInUse($gallery,$overlap) 1
			dbReset $gallery $overlap
			break
		    }
		}
	    }
	}
	
	set currentgallery $gallery
	set currentoverlap $overlap
	
	upvar #1 dbSpecName($currentgallery,$currentoverlap) SpecName
	upvar #1 dbServerName($currentgallery,$currentoverlap) ServerName

	set SpecName $s
        set ServerName $SpectrumServerHost
	
	do_loadSpectrum
	do_reset; do_show
    }

    proc do_XMin {vl} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable mode2
       variable dbXMin

       for {set g 1} {$g<=$numgallery} {incr g} {
          if {$dbInUse($g,1) == 1} {
            if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current

            set dbXMin($g) $vl
          }
       }
   }

    proc do_XMax {vl} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable mode2
       variable dbXMax

       for {set g 1} {$g<=$numgallery} {incr g} {
          if {$dbInUse($g,1) == 1} {
            if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current

            set dbXMax($g) $vl
          }
       }
   }

    proc do_YMin {vl} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable mode2
       variable dbYMin
       variable CustomYView

       for {set g 1} {$g<=$numgallery} {incr g} {
          if {$dbInUse($g,1) == 1} {
            if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current

            set dbYMin($g) $vl
          }
       }

       if {$vl > 0} {set CustomYView 1}
   }

    proc do_YMax {vl} {
       variable currentgallery
       variable numgallery
       variable dbInUse
       variable mode2
       variable dbYMax
       variable CustomYView

       for {set g 1} {$g<=$numgallery} {incr g} {
          if {$dbInUse($g,1) == 1} {
            if {$mode2 == 0 && $g != $currentgallery} {continue}  ;# mode is current

            set dbYMax($g) $vl
          }
       }

       if {$vl > 0} {set CustomYView 1} else {set CustomYView 0}
   }

   proc do_Options {vl} {
      variable OPT 

      switch $vl {
         1  {set OPT "OLCM"}
         2  {set OPT "CM"}
         3  {set OPT "SDC"}
         4  {set OPT "test"}
         99  {set OPT "NULL"}
         default {}
      }

   }

   proc do_ColorPick {f vl} {
        variable CM
        variable CMpalette
        variable OLCM
        variable OLCMpalette
        variable Swatch

       switch $f {
         OLCM  {
            set OLCM(modified) [lreplace [set OLCM($OLCMpalette)] $Swatch $Swatch $vl]
            set OLCMpalette "modified"
         }
         CM  {
            set CM(modified) [lreplace [set CM($CMpalette)] $Swatch $Swatch $vl]
            set CMpalette "modified"
         }
         default {}
       }

   }

    proc do_Palette {vl} {
        variable CMpalette
    
        set CMpalette $vl
    }

    proc do_SDCmode {vl} {
        variable SDCmode
 
        set SDCmode $vl
        do_contours

    }

    proc do_SDCbase {vl} {
        variable SDCbase

        set SDCbase $vl
        do_contours
    }

    proc do_contours {} {
        variable SDCmode
        variable SDCbase
        variable MAXCONTOURS
        variable SDC

        if {$SDCmode == "linear"} {
           for {set i 0} {$i < $MAXCONTOURS} {incr i} {set SDC(c$i) [expr $SDCbase * $i]}
        }

        if {$SDCmode == "log"} {
           set SDC(c0) 0
           set c 1
           for {set i 1} {$i < $MAXCONTOURS} {incr i} {set SDC(c$i) $c; set c [expr $c * $SDCbase]}
        }

        if {$SDCmode == "meis"} {
           set i 0
           foreach c [list 0 8 8 16 16 24 24 32 32 40 40 48 48 56 56 64 64 72 72 80 80 88 88 96 96 104 104 112 112 120 120] {
              set SDC(c$i) $c
              incr i;
           }
        }

    }
 
    
    proc do_click {} {
	variable cgidata
	variable Started
	variable LogFlag
	variable ShowLogFlag
	variable JS
	variable DirName
	variable SpecDim
	variable MemSas
	variable DiscSas
	variable SpectrumList
	variable currentgallery
	variable currentoverlap
	variable Showing
	variable SpecShow
        variable mode2
        variable selectlist
        variable SelectionMode
        variable Swatch
        variable CM
	
	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [lindex $cgidata 1]
		set vl [second [lindex $cgidata 1]]
		
		set showit $Showing
               set Showing 0
		
		switch -glob [lindex $w 0] {
		    
		    RESET    {set Started 0; return}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {variable Reloading; set Reloading 1}
		    VARIABLES {show_variables}
		    
		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }

                    UPDATE {
                        variable AUTOSTATE
                        set sBAK $::DataAcquisition::ACQSERVER
                        set AUTOSTATE 0
                        do_update
                        do_show
			set ::DataAcquisition::ACQSERVER $sBAK
                    }

                    SPECZERO {
                        variable AUTOSTATE
                        set sBAK $::DataAcquisition::ACQSERVER
                        set AUTOSTATE 0
                        do_zero
                        do_update
                        do_show
			set ::DataAcquisition::ACQSERVER $sBAK
                    }
		    
		    SpectrumSERVER {
			variable multimode
			variable mode1

			set SpecNameList ""
			for {set i 0} {$i < [llength $cgidata]} {incr i} {
			    if {[lindex $cgidata $i] == "SPECNAMES"} {incr i; lappend SpecNameList [lindex $cgidata $i]}
			}
			if {$mode1 == 0} {RemoveAllSpectra}
			foreach item $SpecNameList {SelectSpectrum $item}

                        set multimode single
		    }
		    
		    ALLSERVERS {variable allservers; set allservers [expr ($allservers + 1) & 1]}
		    
		    SERVER {
			set ::DataAcquisition::ACQSERVER $vl
			if {$MemSas == 1}  {do_inquiry *}
			if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
			do_show
			set ::DataAcquisition::ACQSERVER $vl
		    }
		    
		    SPECSHOW {
                        set sBAK $::DataAcquisition::ACQSERVER
			switch [lindex $w 1] {
			    0   {do_loadSpectrum}  
			    1   {do_update; do_show} 
			    2   {do_show}
                            3   {do_updateSpectra; do_show}
			}
			set ::DataAcquisition::ACQSERVER $sBAK
		    }
		    
		    MULTIMODE {
			switch [lindex $w 1] {
			    single   {variable multimode; set multimode single}
			    multi    {variable multimode; set multimode multi}
			}
		    }
		    
		    SPECCONT {do_cont [lindex $w 1]}
		    
		    SPECNAMES {
                        variable multimode
                        variable mode1
                        set multimode single
                        if {$mode1 == 0} {RemoveAllSpectra}
                        SelectSpectrum [lindex $w 1]
		    }
		    
		    SPECNAME {
                        if {[string first * [lindex $w 1]] >= 0} {
                            if {$MemSas == 1}  {set SpectrumList [do_inquiry [lindex $w 1]]}
                            if {$DiscSas == 1} {set SpectrumList [do_inquiry [file join $DirName [lindex $w 1]]]}
                        } else {
                            variable multimode
                            variable mode1
                            set multimode single
                            if {$mode1 == 0} {RemoveAllSpectra}
                            SelectSpectrum [lindex $w 1]
                        }
		    }
		    
		    DIRNAMES -
		    DIRNAME {
			set DirName [lindex $w 1]
			if {$MemSas == 1}  {do_inquiry *}
			if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
		    }
		    
		    XMIN     {do_XMin [lindex $w 1]}
		    XMAX     {do_XMax [lindex $w 1]}
		    YMIN     {do_YMin [lindex $w 1]}
		    YMAX     {do_YMax [lindex $w 1]}
		    
		    MODE     {
			switch [lindex $w 1] {
			    0  {variable mode1; set mode1 [expr ($mode1 + 1) & 3]; if {$mode1 == 3} {set mode1 0}}
			    1  {variable mode2; set mode2 [expr ($mode2 + 1) & 1]}
			    2  {variable mode3; set mode3 [expr ($mode3 + 1) & 1]}
			}
		    }

		    SELECT   {
			switch [lindex $w 1] {
			    0  {
                              variable SelectionMode
                              set SelectionMode [expr ($SelectionMode + 1) & 3]
                              if {$SelectionMode == 3} {set SelectionMode 0}
                            }
			}
		    }
		    
		    LAYOUTS {do_layouts [lindex $w 1]}
		    GALLERIES {do_galleries [lindex $w 1]}
		    GALLERY  {set currentgallery [lindex $w 1]; set currentoverlap 1; do_pushtag [lindex $w 2]}
                    CANVAS   {do_canvas [lindex $w 1] [lindex $w 2] [lindex $w 3]}
		    EXPAND   {
			set currentgallery [lindex $w 1]; set currentoverlap 1
                        if {[lindex $selectlist $SelectionMode] == "y"} {
                            do_Yexpand [lindex $w 4] [lindex $w 5]
                        }
                        if {[lindex $selectlist $SelectionMode] == "x"} {
			    do_pushtag [lindex $w 2]
                            do_pushtag [lindex $w 3]
                            do_expand
                        }
                        if {[lindex $selectlist $SelectionMode] == "xy"} {
                            do_Yexpand [lindex $w 4] [lindex $w 5]
			    do_pushtag [lindex $w 2]
                            do_pushtag [lindex $w 3]
                            do_expand
                        }
		    }
		    VIEW     {do_view $w}
		    ARRANGE  {do_arrange $w}
		    ANALYSIS {do_analysis $w}
		    TAGSFITS {do_tagsfits $w}
		    ACTIONS1 {do_actions1 $w}
		    ACTIONS2 {do_actions2 $w}

                    AUTORATE {variable AUTORATE; set AUTORATE [expr [lindex $w 1]*1000]}
                    AUTOOFF  {variable AUTOMODE; set AUTOMODE OFF}
                    AUTOON   {variable AUTOMODE; set AUTOMODE ON}

                    OPTIONS   {do_Options $vl}
                    COLORPICK {do_ColorPick $vl [third [lindex $cgidata 1]]}
                    PALETTE   {do_Palette $vl}
                    SDCMODE   {do_SDCmode $vl}
                    SDCBASE   {do_SDCbase $vl}
		    
		    MainLog {}
		    undefined {}
		    default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"; set showit 0}
		}
	    }
	}
	if {$showit} {
            set sBAK $::DataAcquisition::ACQSERVER
            do_show
            set ::DataAcquisition::ACQSERVER $sBAK
        }
    }
    
    if {$MemSas == 1}  {do_inquiry *}
    if {$DiscSas == 1} {do_inquiry [file join $DirName *]}
    set html ""
    
}   ;# end of if {$Started == 0}



